"use strict";Object.defineProperty(exports, "__esModule", {value: true});







var _types = require('edge-core-js/types');





var _swapHelpers = require('../util/swapHelpers');
var _utils = require('../util/utils');


const pluginId = 'transfer'

const swapInfo = {
  pluginId,
  displayName: 'Transfer',
  orderUri: undefined,
  supportEmail: 'support@edge.com'
}

 function makeTransferPlugin(
  opts
) {
  const fetchSwapQuoteInner = async (
    request
  ) => {
    const {
      publicAddress: toAddress
    } = await request.toWallet.getReceiveAddress({
      tokenId: null
    })

    const spendInfo = {
      tokenId: request.fromTokenId,
      spendTargets: [
        {
          nativeAmount: request.nativeAmount,
          publicAddress: toAddress
        }
      ],
      assetAction: {
        assetActionType: 'transfer'
      },
      savedAction: {
        actionType: 'swap',
        swapInfo,
        isEstimate: false,
        toAsset: {
          pluginId: request.toWallet.currencyInfo.pluginId,
          tokenId: request.toTokenId,
          nativeAmount: request.nativeAmount
        },
        fromAsset: {
          pluginId: request.fromWallet.currencyInfo.pluginId,
          tokenId: request.fromTokenId,
          nativeAmount: request.nativeAmount
        },
        payoutAddress: toAddress,
        payoutWalletId: request.toWallet.id
      }
    }

    return {
      request,
      spendInfo,
      swapInfo,
      fromNativeAmount: request.nativeAmount
    }
  }

  const out = {
    swapInfo,

    async fetchSwapQuote(req) {
      const request = _utils.convertRequest.call(void 0, req)
      if (
        request.fromWallet.currencyInfo.pluginId !==
          request.toWallet.currencyInfo.pluginId ||
        request.fromCurrencyCode !== request.toCurrencyCode
      ) {
        throw new (0, _types.SwapCurrencyError)(swapInfo, request)
      }

      const newRequest = await _swapHelpers.getMaxSwappable.call(void 0, fetchSwapQuoteInner, request)
      const swapOrder = await fetchSwapQuoteInner(newRequest)
      return await _swapHelpers.makeSwapPluginQuote.call(void 0, swapOrder)
    }
  }

  return out
} exports.makeTransferPlugin = makeTransferPlugin;
